<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- Generated by Apache Maven Doxia at Jan 20, 2013 ( $Revision$ ) -->
<!-- $HeadURL: https://svn.apache.org/repos/asf/httpcomponents/maven-skin/trunk/src/main/resources/META-INF/maven/site.vm $ -->
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <title>Apache HttpComponents - HttpComponents News</title>
    <style type="text/css" media="all">
      @import url("./css/maven-base.css");
      @import url("./css/maven-theme.css");
      @import url("./css/site.css");
    </style>
    <link rel="stylesheet" href="./css/print.css" type="text/css" media="print" />
    <meta name="Date-Revision-yyyymmdd" content="20130120" />
    <meta http-equiv="Content-Language" content="en" />
        
        </head>
  <body class="composite">
    <div id="banner">
                        <a href="http://www.apache.org/" id="bannerLeft">
                                        <img src="http://www.apache.org/images/asf_logo_wide.gif" alt="Apache" />
                </a>
                                            <a href="./" id="bannerRight">
                                                <img src="images/logos/httpcomponents.png" alt="HttpComponents" />
                </a>
            <div class="clear">
        <hr/>
      </div>
    </div>
    <div id="breadcrumbs">
            
        
                <div class="xleft">
        <span id="publishDate">Last Published: 2013-01-20</span>
                  &nbsp;| <span id="projectVersion">Version: 7-SNAPSHOT</span>
                      </div>
            <div class="xright">                    <a href="http://www.apache.org/" class="externalLink" title="Apache">Apache</a>
            |
                        <a href="index.html" title="HttpComponents">HttpComponents</a>
              
        
      </div>
      <div class="clear">
        <hr/>
      </div>
    </div>
    <div id="leftColumn">
      <div id="navcolumn">
             
        
                                <h5>HttpComponents</h5>
                  <ul>
                  <li class="none">
                          <a href="index.html" title="Home">Home</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/licenses/" class="externalLink" title="License">License</a>
            </li>
                  <li class="none">
                          <a href="downloads.cgi" title="Download">Download</a>
            </li>
                  <li class="none">
                          <a href="mail.html" title="Mailing Lists">Mailing Lists</a>
            </li>
                  <li class="none">
                          <a href="user-docs.html" title="User documents">User documents</a>
            </li>
                  <li class="none">
                          <a href="dev-docs.html" title="Developer documents">Developer documents</a>
            </li>
                  <li class="none">
                          <a href="http://wiki.apache.org/HttpComponents/" class="externalLink" title="Wiki (external)">Wiki (external)</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/security/" class="externalLink" title="Security">Security</a>
            </li>
          </ul>
                       <h5>Overview</h5>
                  <ul>
                  <li class="none">
                          <a href="index.html" title="About">About</a>
            </li>
                  <li class="none">
            <strong>News</strong>
          </li>
                  <li class="none">
                          <a href="poweredby.html" title="Powered by">Powered by</a>
            </li>
                  <li class="none">
                          <a href="get-involved.html" title="Get Involved">Get Involved</a>
            </li>
          </ul>
                       <h5>Components</h5>
                  <ul>
                  <li class="none">
                          <a href="httpcomponents-client-ga/index.html" title="HttpClient (GA)">HttpClient (GA)</a>
            </li>
                  <li class="none">
                          <a href="httpcomponents-client-dev/index.html" title="HttpClient (DEV)">HttpClient (DEV)</a>
            </li>
                  <li class="none">
                          <a href="httpcomponents-core-ga/index.html" title="HttpCore (GA)">HttpCore (GA)</a>
            </li>
                  <li class="none">
                          <a href="httpcomponents-core-dev/index.html" title="HttpCore (DEV)">HttpCore (DEV)</a>
            </li>
                  <li class="none">
                          <a href="httpcomponents-asyncclient-dev/index.html" title="HttpAsyncClient (DEV)">HttpAsyncClient (DEV)</a>
            </li>
          </ul>
                       <h5>Legacy</h5>
                  <ul>
                  <li class="none">
                          <a href="httpclient-legacy/index.html" title="Commons HttpClient">Commons HttpClient</a>
            </li>
          </ul>
                       <h5>Project</h5>
                  <ul>
                  <li class="none">
                          <a href="status.html" title="Status">Status</a>
            </li>
                  <li class="none">
                          <a href="charter.html" title="Charter">Charter</a>
            </li>
                  <li class="none">
                          <a href="bylaws.html" title="Bylaws">Bylaws</a>
            </li>
                  <li class="none">
                          <a href="goals.html" title="Goals">Goals</a>
            </li>
          </ul>
                       <h5>Project Documentation</h5>
                  <ul>
                                                                                                                          <li class="collapsed">
                          <a href="project-info.html" title="Project Information">Project Information</a>
                  </li>
          </ul>
                       <h5>ASF</h5>
                  <ul>
                  <li class="none">
                          <a href="http://www.apache.org" class="externalLink" title="ASF Home Page">ASF Home Page</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/foundation/" class="externalLink" title="Foundation">Foundation</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/foundation/sponsorship.html" class="externalLink" title="Sponsor Apache">Sponsor Apache</a>
            </li>
                  <li class="none">
                          <a href="http://www.apache.org/foundation/thanks.html" class="externalLink" title="Thanks">Thanks</a>
            </li>
          </ul>
                                                                                                                   <a href="http://www.apache.org/events/current-event.html" title="ApacheCon" class="poweredBy">
        <img class="poweredBy"  alt="ApacheCon" src="http://www.apache.org/events/current-event-125x125.png"    />
      </a>
                                                                                                    <a href="http://maven.apache.org/" title="Maven" class="poweredBy">
        <img class="poweredBy"  alt="Maven" src="http://maven.apache.org/images/logos/maven-feather.png"    />
      </a>
                       
        
            </div>
    </div>
    <div id="bodyColumn">
      <div id="contentBox">
        <!-- ==================================================================== --><!-- Licensed to the Apache Software Foundation (ASF) under one --><!-- or more contributor license agreements.  See the NOTICE file --><!-- distributed with this work for additional information --><!-- regarding copyright ownership.  The ASF licenses this file --><!-- to you under the Apache License, Version 2.0 (the --><!-- "License"); you may not use this file except in compliance --><!-- with the License.  You may obtain a copy of the License at --><!--  --><!-- http://www.apache.org/licenses/LICENSE-2.0 --><!--  --><!-- Unless required by applicable law or agreed to in writing, --><!-- software distributed under the License is distributed on an --><!-- "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY --><!-- KIND, either express or implied.  See the License for the --><!-- specific language governing permissions and limitations --><!-- under the License. --><!-- ==================================================================== --><!--  --><!-- This software consists of voluntary contributions made by many --><!-- individuals on behalf of the Apache Software Foundation.  For more --><!-- information on the Apache Software Foundation, please see --><!-- <http://www.apache.org/>. --><div class="section"><h2>HttpComponents Project News <a name="HttpComponents_Project_News"></a></h2><div class="section"><h3>21 January 2013 - HttpComponents HttpClient 4.3-alpha1 released<a name="a21_January_2013_-_HttpComponents_HttpClient_4.3-alpha1_released"></a></h3><p>This is the first ALPHA release of HttpClient 4.3. The 4.3 branch enhances HttpClient in several key areas and includes several notable features and improvements:</p><ul><li>Support for Java 7 try-with-resources for resource management (connection release.)</li><li>Added fluent Builder classes for HttpEntity, HttpRequest and HttpClient instances. </li><li>Deprecation of preference and configuration API based on HttpParams interface in favor of constructor injection and plain configuration objects.</li><li>Reliance on object immutability instead of access synchronization for thread safety. Several old classes whose instances can be shared by multiple request exchanges have been replaced by immutable equivalents. </li><li>DefaultHttpClient, DecompressingHttpClient, CachingHttpClient and similar classes are deprecated in favor of builder classes that produce immutable HttpClient instances. </li><li>HttpClient builders now dynamically construct a request execution pipeline tailored specifically to the user configuration by physically excluding unnecessary protocol components.</li><li>There is now an option to construct a minimal HttpClient implementation that can only execute basic HTTP message exchanges without redirects, authentication, state management or proxy support. This feature might be of particular use in web crawler development. </li><li>There is now option to avoid strict URI syntax for request URIs by executing HTTP requests with an explicitly specified target host. HttpClient will no longer attempt to parse the request URI if it does not need to extract the target host from it.</li></ul></div><div class="section"><h3>15 January 2013 - HttpComponents HttpClient 4.2.3 (GA) released<a name="a15_January_2013_-_HttpComponents_HttpClient_4.2.3_GA_released"></a></h3><p>This is a bug fix release that addresses a number of issues reported since release 4.2.2. This release also includes a thoroughly reworked NTLM authentication engine which should result in a better compatibility with the newest Microsoft products. </p></div><div class="section"><h3>08 Dec 2012 - Welcome new HttpComponents committer Karl Wright <a name="a08_Dec_2012_-_Welcome_new_HttpComponents_committer_Karl_Wright"></a></h3><p>Karl Wright has been unanimously voted in as a new HttpComponents committer due to his invaluable help in supporting the internal NTLM engine and NTLM related authentication code. Karl is a committer on a number of ASF projects: Lucene, Lucene connectors, Incubator.</p><p>Welcome on board, Karl!</p></div><div class="section"><h3>30 November 2012 - HttpComponents HttpCore 4.3-alpha1 released<a name="a30_November_2012_-_HttpComponents_HttpCore_4.3-alpha1_released"></a></h3><p>This is the first release from the 4.3.x release branch. The main theme of the 4.3 release series is streamlining of component configuration and deprecation of the old configuration API based on HttpParams in favor of constructor-based dependency injection and plain objects for configuration parameters.</p></div><div class="section"><h3>30 November 2012 - HttpComponents HttpCore 4.2.3 (GA) released<a name="a30_November_2012_-_HttpComponents_HttpCore_4.2.3_GA_released"></a></h3><p>HttpCore 4.2.3 is a maintenance release that fixes a number of bugs found since 4.2.2 including a major bug in the NIO module that can cause an infinite loop in SSL sessions under special circumstances when the remote peer terminates the session in the middle of SSL handshake. We advise users of HttpCore NIO of all versions to upgrade.</p></div><div class="section"><h3>25 October 2012 - HttpComponents HttpClient 4.2.2 (GA) released<a name="a25_October_2012_-_HttpComponents_HttpClient_4.2.2_GA_released"></a></h3><p>HttpClient 4.2.2 is a bug fix release that addresses a number of issues reported since release 4.2.1. Users of HttpClient 4.2 are advised to upgrade.</p></div><div class="section"><h3>29 September 2012 - HttpComponents HttpAsyncClient 4.0-beta3 released<a name="a29_September_2012_-_HttpComponents_HttpAsyncClient_4.0-beta3_released"></a></h3><p>This is a maintenance release that picks up the latest bug fixes in the core components.</p></div><div class="section"><h3>23 September 2012 - HttpComponents HttpCore 4.2.2 (GA) released<a name="a23_September_2012_-_HttpComponents_HttpCore_4.2.2_GA_released"></a></h3><p>This is a maintenance release that fixes a number of bugs and regressions found since 4.2.1 including a major bug in the NIO module causing incorrect handling of outgoing Content-Length delimited messages larger than 2GB. Users of HttpCore 4.2 are advised to upgrade.</p></div><div class="section"><h3>29 August 2012 - Welcome new HttpComponents committer William Speirs <a name="a29_August_2012_-_Welcome_new_HttpComponents_committer_William_Speirs"></a></h3><p>William Speirs, a long time contributor to the project, has been unanimously voted in as a new HttpComponents committer. William is already a committer on Apache Commons project.</p><p>Welcome on board, William!</p></div><div class="section"><h3>8 August 2011 - HttpComponents HttpAsyncClient 4.0-beta2 released<a name="a8_August_2011_-_HttpComponents_HttpAsyncClient_4.0-beta2_released"></a></h3><p>This release fixes a number of non-critical issues found since release 4.0-beta1 and introduces basic support for HTTP/1.1 response caching. Please note that caching for streaming HTTP exchanges is currently not supported.</p></div><div class="section"><h3>4 August 2012 - Welcome new HttpComponents committer Gary Gregory <a name="a4_August_2012_-_Welcome_new_HttpComponents_committer_Gary_Gregory"></a></h3><p>By 5 binding votes in favor Gary Gregory has been unanimously voted in as a new HttpComponents committer. Gary is already a committer on Apache Commons, Logging and Xalan projects.</p><p>Welcome on board, Gary!</p></div><div class="section"><h3>5 July 2012 - HttpComponents HttpClient 4.2.1 (GA) released<a name="a5_July_2012_-_HttpComponents_HttpClient_4.2.1_GA_released"></a></h3><p>HttpClient 4.2.1 is a bug fix release that addresses a number of issues reported since release 4.2. Users of HttpClient 4.2 are advised to upgrade.</p></div><div class="section"><h3>14 June 2012 - HttpComponents HttpCore 4.2.1 (GA) released<a name="a14_June_2012_-_HttpComponents_HttpCore_4.2.1_GA_released"></a></h3><p>HttpCore 4.2.1 is a patch release that fixes a number of non-critical bugs found since 4.2. Users of HttpCore 4.2 are advised to upgrade.</p></div><div class="section"><h3>22 May 2012 - HttpComponents HttpClient 4.2 (GA) released<a name="a22_May_2012_-_HttpComponents_HttpClient_4.2_GA_released"></a></h3><p>This is the first stable (GA) release of HttpClient 4.2. The most notable enhancements included in this release are:</p><ul><li>New facade API for HttpClient based on the concept of a fluent interface. The fluent API exposes only the most fundamental functions of HttpClient and is intended for relatively simple use cases that do not require the full flexibility of HttpClient. However, the fluent API almost fully relieves the users from having to deal with connection management and resource deallocation.</li><li>Redesigned and rewritten connection management code. </li><li>Enhanced HTTP authentication API that enables HttpClient to handle more complex authentication scenarios. HttpClient 4.2 is now capable of making use of multiple authentication challenges and retry authentication with a fall-back scheme in case the primary one fails. This can be important for compatibility with Microsoft products that are often configured to use SPNEGO/Kerberos as the preferred authentication scheme. </li></ul></div><div class="section"><h3>5 May 2012 - HttpComponents HttpCore 4.2 (GA) released<a name="a5_May_2012_-_HttpComponents_HttpCore_4.2_GA_released"></a></h3><p>This is the first stable (GA) release of HttpCore 4.2. The most notable features included in this release are connection pool components for blocking and non-blocking HTTP connections and new asynchronous client and server side protocol handlers.</p><p>New protocol handling API used in conjunction with connection pooling components is expected to make development of asynchronous HTTP client agents and HTTP proxies easier and less error prone.</p><p>Connection pool components are based on mature code migrated from HttpClient and HttpAsyncClient modules but have a slightly different API that makes a better use of Java standard concurrent primitives. </p></div><div class="section"><h3>22 February 2012 - HttpComponents HttpAsyncClient 4.0-beta1 released<a name="a22_February_2012_-_HttpComponents_HttpAsyncClient_4.0-beta1_released"></a></h3><p>This the first BETA release of HttpAsyncClient. This release completes the application programming interface and the feature set of HttpAsyncClient and upgrades to the latest versions of core and client components (HttpCore 4.2-beta1 and HttpClient 4.2-beta1). As of this release HttpAsyncClient is expected to be API stable.</p></div><div class="section"><h3>10 February 2012 - HttpComponents HttpClient 4.2-beta1 released<a name="a10_February_2012_-_HttpComponents_HttpClient_4.2-beta1_released"></a></h3><p>This is the first BETA release of HttpClient 4.2. This release completes development of several notable enhancements in HttpClient: new facade API, redesigned connection management code and new HTTP authentication API.</p></div><div class="section"><h3>7 February 2012 - HttpComponents HttpClient 4.1.3 (GA) released<a name="a7_February_2012_-_HttpComponents_HttpClient_4.1.3_GA_released"></a></h3><p>HttpClient 4.1.3 is a bug fix release that addresses a number of non-critical issues found since 4.1.2 primarily in the HTTP caching module.</p></div><div class="section"><h3>1 February 2012 - HttpComponents HttpCore 4.2-beta1 released<a name="a1_February_2012_-_HttpComponents_HttpCore_4.2-beta1_released"></a></h3><p>This is the first BETA release of HttpCore 4.2. This release ships with an improved asynchronous protocol handling API and new non-blocking client and server HTTP protocol handler implementations. New API is expected to be more flexible especially for writing HTTP proxy or gateway type of services. Upstream projects are encouraged to evaluate the new API and give feedback.</p></div><div class="section"><h3>23 December 2011 - HttpComponents HttpCore 4.1.4 (GA) released<a name="a23_December_2011_-_HttpComponents_HttpCore_4.1.4_GA_released"></a></h3><p>HttpCore 4.1.4 is a patch release that fixes a number of bugs found since 4.1.3. It is also likely to be the last release in the 4.1.x branch.</p></div><div class="section"><h3>3 November 2011 - HttpComponents HttpClient 4.2-alpha1 released<a name="a3_November_2011_-_HttpComponents_HttpClient_4.2-alpha1_released"></a></h3><p>This is the first ALPHA release of HttpClient 4.2. The 4.2 branch enhances HttpClient in several key areas and includes several notable features and improvements: new facade API, redesigned connection management code and new HTTP authentication API.</p></div><div class="section"><h3>29 September 2011 - HttpComponents HttpAsyncClient 4.0-alpha3 released<a name="a29_September_2011_-_HttpComponents_HttpAsyncClient_4.0-alpha3_released"></a></h3><p>This is the third ALPHA release of HttpAsyncClient 4.0. This release largely completes the application programming interface and feature set of HttpAsyncClient. While the API may still change in the course of the ALPHA development phase, this is expected to be the last round of major API changes and the API is expected to be reasonably stable as of this release.</p></div><div class="section"><h3>23 September 2011 - HttpComponents HttpCore 4.2-alpha2 released<a name="a23_September_2011_-_HttpComponents_HttpCore_4.2-alpha2_released"></a></h3><p>This is the second ALPHA release of HttpCore 4.2. This release comes with completely redesigned and rewritten asynchronous protocol handlers. New protocol handling API used in conjunction with connection pooling components introduced in the previous ALPHA release is expected to make development of asynchronous HTTP client agents and HTTP proxies easier and less error prone.</p></div><div class="section"><h3>19 August 2011 - HttpComponents HttpCore 4.2-alpha1 released<a name="a19_August_2011_-_HttpComponents_HttpCore_4.2-alpha1_released"></a></h3><p>This is the first ALPHA release of the 4.2 development branch. The most notable feature included in this release is support for connection pools of blocking and non-blocking HTTP connections. Connection pool components are based on mature code migrated from HttpClient and HttpAsyncClient modules but have a slightly different API that makes a better use of Java standard concurrent primitives. Support for connection pools in HttpCore is expected to make development of client and proxy HTTP services easier and less error prone.</p></div><div class="section"><h3>7 August 2011 - HttpComponents HttpClient 4.1.2 (GA) released<a name="a7_August_2011_-_HttpComponents_HttpClient_4.1.2_GA_released"></a></h3><p>HttpClient 4.1.2 is a bug fix release that addresses a number of non-critical issues reported since release 4.1.1.</p></div><div class="section"><h3>31 July 2011 - HttpComponents HttpCore 4.1.3 (GA) released<a name="a31_July_2011_-_HttpComponents_HttpCore_4.1.3_GA_released"></a></h3><p>HttpCore 4.1.3 is a patch release that fixes a critical regression in the non-blocking SSL I/O session code introduced in the 4.1.2 release.</p></div><div class="section"><h3>18 July 2011 - HttpComponents HttpCore 4.1.2 (GA) released<a name="a18_July_2011_-_HttpComponents_HttpCore_4.1.2_GA_released"></a></h3><p>HttpCore 4.1.2 is a patch release that fixes a number of non-critical issues found since release 4.1.1.</p></div><div class="section"><h3>24 May 2011 - HttpComponents HttpAsyncClient 4.0-alpha2 released<a name="a24_May_2011_-_HttpComponents_HttpAsyncClient_4.0-alpha2_released"></a></h3><p>The second ALPHA release of HttpAsyncClient 4.0 comes with a number of important improvements and enhancements. As of this version HttpAsyncClient fully supports HTTP state management (cookies) and HTTP authentication (basic, digest, NTLM, spnego/kerberos). Connection management classes have been thoroughly reworked and improved. This version also improves support for zero copy file upload / download operations.</p></div><div class="section"><h3>20 May 2011 - HttpComponents HttpCore 4.1.1 (GA) released<a name="a20_May_2011_-_HttpComponents_HttpCore_4.1.1_GA_released"></a></h3><p>HttpCore 4.1.1 is a patch release that fixes a number of non-critical issues found since release 4.1.</p><p>This release marks the end of support for Java 1.3. As of release 4.2 HttpCore will require Java 1.5 for all its components.</p></div><div class="section"><h3>20 March 2011 - HttpComponents HttpClient 4.1.1 (GA) released<a name="a20_March_2011_-_HttpComponents_HttpClient_4.1.1_GA_released"></a></h3><p>HttpClient 4.1.1 is a bug fix release that addresses a number of issues reported since release 4.1, including one critical security issue.</p></div><div class="section"><h3>23 January 2011 - HttpComponents HttpClient 4.1 (GA) released<a name="a23_January_2011_-_HttpComponents_HttpClient_4.1_GA_released"></a></h3><p>The HttpClient 4.1 release builds upon the stable foundation laid by HttpClient 4.0 and adds several functional improvements and popular features.</p><ul><li>Response caching conditionally compliant with HTTP/1.1 specification (full compliance with MUST requirements, partial compliance with SHOULD requirements)</li><li>Full support for NTLMv1, NTLMv2, and NTLM2 Session authentication. The NTLM protocol code was kindly contributed by the Lucene Connector Framework project.</li><li>Support for SPNEGO/Kerberos authentication.</li><li>Persistence of authentication data between request executions within the same execution context.</li><li>Support for preemptive authentication for BASIC and DIGEST schemes.</li><li>Support for transparent content encoding. Please note transparent content encoding is not enabled per default in order to avoid conflicts with already existing custom content encoding solutions.</li><li>Mechanism to bypass the standard certificate trust verification (useful when dealing with self-signed certificates).</li><li>Simplified configuration for connection managers.</li><li>Transparent support for host multihoming.</li></ul></div><div class="section"><h3>18 January 2011 - HttpComponents HttpAsyncClient 4.0-alpha1 released<a name="a18_January_2011_-_HttpComponents_HttpAsyncClient_4.0-alpha1_released"></a></h3><p>This is the first public release of HttpAsyncClient. The HttpAsyncClient 4.0 API is considered very experimental and is expected to change in the course of the ALPHA development phase. This release is primarily intended for early adopters who may be interested in contributing to the project and in helping shape the new API.</p></div><div class="section"><h3>21 November 2010 - HttpComponents HttpClient 4.1-beta1 released<a name="a21_November_2010_-_HttpComponents_HttpClient_4.1-beta1_released"></a></h3><p>This release finalizes the 4.1 API and brings a number of major improvements to the HTTP caching module. This release also adds full support for NTLMv1, NTLMv2, and NTLM2 Session authentication schemes. The NTLM protocol code was kindly contributed by the Lucene Connector Framework project.</p></div><div class="section"><h3>19 November 2010 - HttpComponents HttpCore 4.1 (GA) released<a name="a19_November_2010_-_HttpComponents_HttpCore_4.1_GA_released"></a></h3><p>This is the first stable release of HttpCore 4.1. This release provides a compatibility mode with JREs that have a naive (broken) implementation of SelectionKey API and also improves compatibility with the Google Android platform. There has also been a number of performance related improvements and bug fixes in both blocking and non-blocking components.</p></div><div class="section"><h3>26 October 2010 - Welcome new HttpComponents committer Jonathan Moore <a name="a26_October_2010_-_Welcome_new_HttpComponents_committer_Jonathan_Moore"></a></h3><p>By 4 binding votes in favor and none against Jonathan Moore has been voted in as a new HttpComponents committer. Jonathan has made major contributions to the new HttpClient caching module.</p><p>Welcome on board, Jonathan!</p></div><div class="section"><h3>19 September 2010 - HttpComponents HttpClient 4.0.3 (GA) released<a name="a19_September_2010_-_HttpComponents_HttpClient_4.0.3_GA_released"></a></h3><p>This is an emergency release fixing a critical regression in the SSL connection management code.</p></div><div class="section"><h3>9 September 2010 - HttpComponents HttpClient 4.0.2 (GA) released<a name="a9_September_2010_-_HttpComponents_HttpClient_4.0.2_GA_released"></a></h3><p>This is a maintenance release that fixes a number of bugs found since 4.0.1. This is likely to be the last release in the 4.0.x branch.</p></div><div class="section"><h3>30 August 2010 - HttpComponents HttpCore 4.1-beta2 released<a name="a30_August_2010_-_HttpComponents_HttpCore_4.1-beta2_released"></a></h3><p>This release addresses fixes a number of non-critical bugs. It is likely to be the last BETA release in the 4.1 branch.</p></div><div class="section"><h3>19 May 2010 - HttpComponents HttpClient 4.1-alpha2 released<a name="a19_May_2010_-_HttpComponents_HttpClient_4.1-alpha2_released"></a></h3><p>This release fixes a number of non-severe bugs discovered since the last release and introduces support for two frequently requested features:</p><ul><li>HTTP/1.1 response caching</li><li>transparent support for host multihoming</li><li>a mechanism to bypass the standard certificate trust verification (useful when dealing with self-signed certificates)</li></ul></div><div class="section"><h3>3 April 2010 - HttpComponents HttpCore 4.1-beta1 released<a name="a3_April_2010_-_HttpComponents_HttpCore_4.1-beta1_released"></a></h3><p>This release finalizes the API introduced in the 4.1 development branch. It also fixes a number of bugs discovered since the previous release and delivers a number of performance optimizations in the blocking HTTP transport components. The blocking HTTP transport is expected to be 5% to 10% faster compared to previous releases.</p></div><div class="section"><h3>11 December 2009 - HttpComponents HttpClient 4.1-alpha1 released<a name="a11_December_2009_-_HttpComponents_HttpClient_4.1-alpha1_released"></a></h3><p>This release builds on the stable 4.0 release and adds several functionality improvements and new features.</p><ul><li>Simplified configuration of connection managers.</li><li>Persistence of authentication data between request executions within the same execution context.</li><li>Support for SPNEGO/Kerberos authentication scheme</li><li>Support for transparent content encoding. Please note transparent content encoding is not enabled per default in order to avoid conflicts with already existing custom content encoding solutions.</li></ul></div><div class="section"><h3>11 December 2009 - HttpComponents HttpClient 4.0.1 (GA) released<a name="a11_December_2009_-_HttpComponents_HttpClient_4.0.1_GA_released"></a></h3><p>This is a bug fix release that addresses a number of issues discovered since the previous stable release. None of the fixed bugs is considered critical. Most notably this release eliminates dependency on JCIP annotations.</p><p>This release is also expected to improve performance by 5 to 10% due to elimination of unnecessary Log object lookups by short-lived components.</p></div><div class="section"><h3>12 September 2009 - HttpComponents HttpCore 4.1-alpha1 released<a name="a12_September_2009_-_HttpComponents_HttpCore_4.1-alpha1_released"></a></h3><p>This is the first public release from the 4.1 branch of HttpCore. This release adds a number of new features, most notable being introduction of compatibility mode with IBM JREs and other JREs with naive (broken) implementation of SelectionKey API.</p></div><div class="section"><h3>14 August 2009 - HttpComponents HttpClient 4.0 (GA) released<a name="a14_August_2009_-_HttpComponents_HttpClient_4.0_GA_released"></a></h3><p>This the first stable (GA) release in the 4.x code line. This release completes the rewrite of HttpClient and delivers a complete API documentation and fixes a few minor bugs reported since the previous release.</p></div><div class="section"><h3>22 June 2009 - HttpComponents HttpCore 4.0.1 (GA) released<a name="a22_June_2009_-_HttpComponents_HttpCore_4.0.1_GA_released"></a></h3><p>This is a patch release addressing a number of issues discovered since the 4.0 release.</p></div><div class="section"><h3>26 February 2009 - HttpComponents HttpCore 4.0 (GA) released<a name="a26_February_2009_-_HttpComponents_HttpCore_4.0_GA_released"></a></h3><p>This the first stable (GA) release in the 4.x code line. This release delivers complete API documentation and fixes a few minor bugs reported since the previous release.</p></div><div class="section"><h3>20 December 2008 - HttpComponents HttpClient 4.0-beta2 released<a name="a20_December_2008_-_HttpComponents_HttpClient_4.0-beta2_released"></a></h3><p>The second BETA of HttpComponents HttpClient addresses a number of issues discovered since the previous release. </p><p>The only significant new feature is an addition of an OSGi compliant bundle combining HttpClient and HttpMime jars.</p><p>All upstream projects are strongly encouraged to upgrade.</p></div><div class="section"><h3>19 October 2008 - HttpComponents HttpCore 4.0-beta3 released<a name="a19_October_2008_-_HttpComponents_HttpCore_4.0-beta3_released"></a></h3><p>The third BETA version of HttpComponents Core addresses a number of issues discovered since the previous release. </p><p>The only significant new feature is an addition of an OSGi compliant bundle combining HttpCore and HttpCore NIO jars.</p></div><div class="section"><h3>12 September 2008 - HttpClient is one of the best open source development tools<a name="a12_September_2008_-_HttpClient_is_one_of_the_best_open_source_development_tools"></a></h3><p>HttpClient is among the 60 winners of InfoWorlds <a class="externalLink" href="http://www.infoworld.com/article/08/08/04/32TC-bossies-2008_1.html"> &quot;Best of Open Source Software Awards 2008&quot;</a>.</p><p>HttpClient was selected as one of the <a class="externalLink" href="http://www.infoworld.com/slideshow/2008/08/166-best_of_open_so-4.html"> best open source development tools</a>.</p></div><div class="section"><h3>29 August 2008 - HttpComponents HttpClient 4.0-beta1 released<a name="a29_August_2008_-_HttpComponents_HttpClient_4.0-beta1_released"></a></h3><p>The first BETA brings yet another round of API enhancements and improvements in the area of connection management. Among the most notable ones is the capability to handle stateful connections such as persistent NTLM connections and private key authenticated SSL connections.</p><p>This is the first API stable release of HttpClient 4.0. All further releases in the 4.0 code line will maintain API compatibility with this release.</p></div><div class="section"><h3>22 June 2008 - HttpComponents HttpCore 4.0-beta2 released<a name="a22_June_2008_-_HttpComponents_HttpCore_4.0-beta2_released"></a></h3><p>The second BETA version of HttpComponents Core added a number of improvements to the NIO components, most notable being improved asynchronous client side and server side protocol handlers.</p></div><div class="section"><h3>09 May 2008 - HttpComponents HttpClient 4.0-alpha4 released<a name="a09_May_2008_-_HttpComponents_HttpClient_4.0-alpha4_released"></a></h3><p>The fourth ALPHA marks the completion of the overhaul of the connection management code in HttpClient. All known shortcomings of the old HttpClient 3.x connection management API have been addressed.</p></div><div class="section"><h3>03 May 2008 - Welcome new HttpComponents committer Sam Berlin <a name="a03_May_2008_-_Welcome_new_HttpComponents_committer_Sam_Berlin"></a></h3><p>By 6 binding votes in favor and none against Sam Berlin has been voted in as a new HttpComponents committer. Sam made several valuable contributions to both core and client components in the course of the past several months.</p><p>Welcome on board, Sam!</p></div><div class="section"><h3>26 February 2008 - HttpComponents HttpClient 4.0-alpha3 released <a name="a26_February_2008_-_HttpComponents_HttpClient_4.0-alpha3_released"></a></h3><p>The third ALPHA release brings another round of API refinements and improvements in functionality. As of this release HttpClient requires Java 5 compatible runtime environment and takes full advantage of generics and new concurrency primitives. </p><p>This release also introduces new default cookie policy that selects a cookie specification depending on the format of cookies sent by the target host. It is no longer necessary to know beforehand what kind of HTTP cookie support the target host provides. HttpClient is now able to pick up either a lenient or a strict cookie policy depending on the compliance level of the target host.</p><p>Another notable improvement is a completely reworked support for multipart entities based on Apache mime4j library.</p></div><div class="section"><h3>24 January 2008 - HttpComponents HttpCore 4.0-beta1 released <a name="a24_January_2008_-_HttpComponents_HttpCore_4.0-beta1_released"></a></h3><p>The first BETA version of HttpComponents Core has been released. This release can be considered a major milestone, as it marks the end of API instability in HttpCore. As of this release the API compatibility between minor releases in 4.x codeline will be maintained.</p><p>This release includes several major improvements such as enhanced HTTP message parsing API and optimized parser implementations, Java 5.0 compatibility for HttpCore NIO extensions.</p><p>The focus of the development efforts will be gradually shifting towards providing better test coverage, documentation and performance optimizations. </p></div><div class="section"><h3>15 November 2007 - HttpComponents becomes TLP<a name="a15_November_2007_-_HttpComponents_becomes_TLP"></a></h3><p>The ASF board had approved HttpComponents 'graduation' from Jakarta to a TLP of its own.</p><p>We are now Apache HttpComponents Project!</p></div><div class="section"><h3>7 November 2007 - HttpComponents HttpClient 4.0-alpha2 released <a name="a7_November_2007_-_HttpComponents_HttpClient_4.0-alpha2_released"></a></h3><p>The second ALPHA release is another important milestone in the redesign of HttpClient. The release includes a number of improvements since ALPHA1, among which are improved connection pooling, support for proxy chains, redesigned HTTP state and authentication credentials management API, improved RFC 2965 cookie specification. </p></div><div class="section"><h3>9 October 2007 - HttpComponents HttpCore 4.0-alpha6 released <a name="a9_October_2007_-_HttpComponents_HttpCore_4.0-alpha6_released"></a></h3><p>The sixth ALPHA version of HttpComponents Core has been released. This release sports an improved message parsing and formatting API in the base module and lots of incremental improvements and bug fixes in the NIO and NIOSSL modules. Based on the improved API, it is now possible to send and receive SIP messages with HttpComponents Core.</p></div><div class="section"><h3>20 July 2007 - HttpComponents HttpClient 4.0-alpha1 released <a name="a20_July_2007_-_HttpComponents_HttpClient_4.0-alpha1_released"></a></h3><p>This release represents a complete, ground-up redesign and almost a complete rewrite of the old HttpClient 3.x codeline. This release finally addresses several design flaws that existed since the 1.0 release and could not be fixed without a major code overhaul and breaking API compatibility. </p><p>Notable changes and enhancements: </p><ul><li>Redesign of the HttpClient internals addressing all known major architectural shortcomings of the 3.x codeline </li><li>Cleaner, more flexible and expressive API </li><li>Better performance and smaller memory footprint due to a more efficient HTTP transport based on HttpCore. HttpClient 4.0 is expected to be 10% to 25% faster than HttpClient 3.x codeline</li><li>More modular structure </li><li>Pluggable redirect and authentication handlers </li><li>Support for protocol incerceptors</li><li>Improved connection management </li><li>Improved support for sending requests via a proxy or a chain of proxies </li><li>Improved handling redirects of entity enclosing requests</li><li>More flexible SSL context customization </li><li>Reduced intermediate garbage in the process of generating HTTP requests and parsing HTTP responses </li></ul></div><div class="section"><h3>4 July 2007 - HttpComponents HttpCore 4.0-alpha5 released <a name="a4_July_2007_-_HttpComponents_HttpCore_4.0-alpha5_released"></a></h3><p>The fifth ALPHA version of HttpComponents Core has been released. This release delivers a number of incremental improvements across the board in all modules and adds several performance oriented features such as ability to transfer data directly between a file and a socket NIO channels. </p></div><div class="section"><h3>30 March 2007 - HttpComponents HttpCore 4.0-alpha4 released <a name="a30_March_2007_-_HttpComponents_HttpCore_4.0-alpha4_released"></a></h3><p>The fourth ALPHA version fixes a number of bugs and adds a number of improvements to HttpCore base and the HttpCore NIO extensions. This release also introduces NIOSSL extensions that can be used to extend HttpCore non-blocking transport components with the ability to transparently encrypt data in transit using SSL/TLS.</p></div><div class="section"><h3>6 December 2006 - HttpComponents HttpCore 4.0-alpha3 released <a name="a6_December_2006_-_HttpComponents_HttpCore_4.0-alpha3_released"></a></h3><p>The third ALPHA version of HttpCore has been released. The ALPHA3 release includes a number of API optimizations and improvements and introduces a set of NIO extensions to the HttpCore API. NIO extensions can be used to build HTTP services intended to handle thousands of simultaneous connections with a small number of I/O threads.</p></div><div class="section"><h3>9 June 2006 - HttpComponents HttpCore 4.0-alpha2 released <a name="a9_June_2006_-_HttpComponents_HttpCore_4.0-alpha2_released"></a></h3><p>The second ALPHA version of HttpCore has been released, which addresses a number of non-critical problems found in the previous release. The upstream projects are strongly encouraged use this release as a dependency while HttpCore undergoes another round of reviews and optimization in the SVN trunk.</p></div><div class="section"><h3>12 May 2006 - HttpClient issue tracking migrated to Jira<a name="a12_May_2006_-_HttpClient_issue_tracking_migrated_to_Jira"></a></h3><p>HttpClient issue tracking has migrated from Bugzilla to Jira. Please use <a class="externalLink" href="http://issues.apache.org/jira/browse/HTTPCLIENT">this project</a> in Jira to report new issues against HttpClient and search for reported ones. All existing issue reports can be accessed in Jira by their original Bugzilla bug id. </p></div><div class="section"><h3>29 April 2006 - New Project Logo <a name="a29_April_2006_-_New_Project_Logo"></a></h3><p>HttpComponents project now has a brand new logo kindly contributed by Regula Wernli.</p><p>Many thanks, Regula! </p></div><div class="section"><h3>23 April 2006 - HttpComponents HttpCore 4.0-alpha1 released <a name="a23_April_2006_-_HttpComponents_HttpCore_4.0-alpha1_released"></a></h3><p>This is the first ALPHA release of HttpCore intended for API review and use in experimental projects. The HttpCore API is still deemed unstable and it can still undergo significant changes based on the feedback from early adopters. </p></div><div class="section"><h3>12 February 2006 - Welcome new HttpComponents committer Roland Weber <a name="a12_February_2006_-_Welcome_new_HttpComponents_committer_Roland_Weber"></a></h3><p>By 5 binding votes in favor and none against Roland Weber has been voted in as a new HttpComponents committer. Roland has been an invaluable contributor to the Jakarta Commons HttpClient project for many years and he is the very first committer to join the Jakarta HttpComponents project.</p><p>Welcome, Roland</p></div><div class="section"><h3>31 October 2005 - Jakarta HttpClient becomes Jakarta HttpComponents<a name="a31_October_2005_-_Jakarta_HttpClient_becomes_Jakarta_HttpComponents"></a></h3><p>By the count 15 votes in favor, Jakarta HttpClient as been renamed as Jakarta HttpComponents. The Jakarta PMC has approved the new project charter and the new project scope.</p></div><div class="section"><h3>16 April 2004 - Welcome Jakarta HttpClient!<a name="a16_April_2004_-_Welcome_Jakarta_HttpClient"></a></h3><p>By the count 26 votes in favor, none against, Jakarta Commons HttpClient as been promoted to the Jakarta sub-project level </p></div></div>
      </div>
    </div>
    <div class="clear">
      <hr/>
    </div>
    <div id="footer">
                      
<div class="xleft">Apache HttpComponents, Commons HttpClient, Apache, the Apache feather logo, and the Apache HttpComponents project logo are trademarks of The Apache Software Foundation.</div>
            
<br/>
            
<div class="xleft">All other marks mentioned may be trademarks or registered trademarks of their respective owners.</div>
                <div class="xright">Copyright &#169;                    2005-2013
                        <a href="http://www.apache.org/">Apache Software Foundation</a>.
            All Rights Reserved.      
        
      </div>
      <div class="clear">
        <hr/>
      </div>
    </div>
  </body>
</html>
